import java.util.Calendar;

import java.util.ArrayList;
import java.util.Arrays;

color[] spring = { #e4572e, #17bebb, #f7b500, #2e282a, #76b041};
color[] summer = { #456990, #49beaa, #149dcb, #edaf4b, #f26157};
color[] autumn1 = { #db633b, #ac9969, #a07366, #cc9861, #ccb25d};
color[] autumn2 = { #f9562d, #fe9b01, #e8c800, #beb500, #86b029};
color[] winter = { #a1a7be, #c2cbd1, #94958b, #beab8b, #394c44};

ArrayList<color[]> seasons = new ArrayList<color[]>(Arrays.asList(spring, summer, autumn1, autumn2, winter));
int season = 0;

color[] daylight = { #1c4686, #236db3, #3c7bbc, #91bee7, #cee3f7};
color[] evening = { #601655, #be487c, #d5648f, #d07b9d, #e2a39d};

ArrayList<color[]> skies = new ArrayList<color[]>(Arrays.asList(daylight, evening));
int sky = 0;

int layers = 4;
int hillsPerLayer = 6;

void setup(){
  size(1920, 512);
  //fullScreen();
  //stroke(0);
  noStroke();
  frameRate(1);
}

void draw(){
  background(skies.get(sky)[(int)random(5)]);
  
  int i = (int)random(5);
  for(int l = 1; l <= layers; l++){
    filter(BLUR, 1);
        
    int hillColor = seasons.get(season)[(i++) % 5];
        
    for(int h = 0; h < hillsPerLayer + 6/l; h++){    
      
      int hillWidth = 300 + 80*l + (int)random(-30, 30);
      int hillHeight = 500 - 110*l + (int)random(-30, 30);
    
      pushMatrix();
        translate(random(width), height - hillHeight/2);
        fill(hillColor);
        triangle(-hillWidth/2, hillHeight/2, hillWidth/2, hillHeight/2, 0, -hillHeight/2);
        fill(0, random((hillsPerLayer + 6/l - h - 1) * 5, (hillsPerLayer + 6/l - h - 1) * 10));
        triangle(-hillWidth/2, hillHeight/2, hillWidth/2, hillHeight/2, 0, -hillHeight/2);
      popMatrix();   
    }         
  }  
}

void keyPressed(){
  if(key == 's'){
    saveFrame("screen-" + timestamp() + "-####.png");
  }
  
  if(key == 'b' && sky == 0){
    sky = 1;
  }else if(key == 'b'){
    sky = 0;
  }
  
  if(key == '0'){
    season = 0;
  }else if(key == '1'){
    season = 1;
  }else if(key == '2'){
    season = 2;
  }else if(key == '3'){
    season = 3;
  }else if(key == '4'){
    season = 4;
  }
}

String timestamp() {
  Calendar now = Calendar.getInstance();
  return String.format("%1$ty%1$tm%1$td_%1$tH%1$tM%1$tS", now);
}